# -*- coding: utf-8 -*-
from setuphelpers import *
import json
import platform

uninstallkey = []
bin_name_temp = 'ultradefrag-%s.bin.i386.exe'
bin_end = '.exe'
app_name = 'Ultra Defragmenter'
path = makepath(programfiles,'UltraDefrag','uninstall.exe')


def install():
    # Specific app values
    package_version = control.version.split('-')[0].split('.')[:3]
    package_version = '.'.join(package_version)
    bin_name = bin_name_temp % package_version
    print('installing ultradefrag')
    install_exe_if_needed(bin_name,'/S',key='UltraDefrag',min_version=package_version)


def update_package():
    print('Download/Update package content from upstream binary sources')

    # Initializing variables

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system()=='Windows' and isfile(makepath(user_local_appdata(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxy = {'http':proxywapt,'https':proxywapt}

    # Specific app values
    app_name = control.name
    proxies = proxy
    git_repo = 'ultradefrag'
    url_api = 'https://sourceforge.net/projects/%s/best_release.json' % git_repo

    # Getting latest version from official website
    print('API used is: ' + url_api)
    json_load = json.loads(wgets(url_api,proxies=proxies))
    version = json_load['release']['filename'].split('/')[-2]
    latest_bin = bin_name_temp % version
    url_dl = 'https://sourceforge.net/projects/%s/files/%s/download' % (git_repo,latest_bin)

    print("Latest %s version is: %s" % (app_name,version))
    print("Download url is: %s" % url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print('Downloading: %s' % latest_bin)
        wget(url_dl,latest_bin,proxies=proxy)
    
    # Incrementing version of the package
    control.version = '%s-%s'%(version,int(control.version.split('-')[-1])+1)
    control.save_control_to_wapt()
    print('Changing package version to: %s in WAPT\\control' % control.version)
